package ru.ispras.telecomtesk.tlsv13.TestsServer;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import jatva.lang.GraphExplorer;
import java.util.Date;
import java.lang.invoke.MethodHandles;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSserverSpecification.*;

@jatva.lang.annotation.ScenarioClass
public 
class TestRecordProtocol
    extends jatva.lang.TestingModel
{

    @jatva.lang.annotation.JTSInternal
    public TestRecordProtocol() {}

    @Override
    @jatva.lang.annotation.JTSInternal
    public jatva.lang.AbstractAction _ts_initialize()
    {
        return new jatva.lang.SimpleAction( 0 /* Handshake */ );
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected int _ts_getMaxMethodNumber()
    { return 1; }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected jatva.lang.AbstractAction _ts_nextDeclared( int currentMethodNumber )
    {
        switch( currentMethodNumber )
        {
            case 0: return new AbstractAction_RecordProtocolApplication();
            default:
                return super._ts_nextDeclared( currentMethodNumber );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected void _ts_executeDeclared( jatva.lang.AbstractAction _par_action )
    {
        switch( _par_action.method() )
        {
            case 0:
                _ts_partialExecute_Handshake( _par_action );
                break;
            case 1:
                _ts_partialExecute_RecordProtocolApplication( _par_action );
                break;
            default:
                super._ts_executeDeclared( _par_action );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected String _ts_getScenMethodName( int method_number )
    {
        switch( method_number )
        {
            case 0:
                return "Handshake";
            case 1:
                return "RecordProtocolApplication";
            default:
                return super._ts_getScenMethodName( method_number );
        }
    }

    public
    TLSServerScenProp scenParam;

    public
    String scenName;

    private
    String currentClassName;

    public
    TestRecordProtocol( String logFileName)
    {
        super( );
        DebugInfo.debugLevel = 4;
        DebugInfo.maxDumpSize = 400;
        currentClassName = MethodHandles.lookup(  ).lookupClass(  ).getSimpleName(  );
        scenParam = new TLSServerScenProp( logFileName, currentClassName );

        TLSConnectionSelector sel = new TLSConnectionSelector( null, null, 0, 0 );
        scenParam.current_connection = new TLSConnection( sel, ConnectionRole.CLIENT );

        GraphExplorer xxx = new DFSMExplorer(  );
        xxx.setMaximumNumberOfTransitions( 5000 );
        xxx.setNumberOfNoncriticalErrorsToIgnore( 5000 );
        setTestEngine( xxx );
    }

    @jatva.lang.annotation.StateBlock
    public 
    Object _ts_state()
    {
        try
        {
            return (scenParam.target.getCurrentState(  ).connected && scenParam.target.isHandshakeComplete(  ));
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.GenStateCalculationException
                ( this
                , _lv_error
                );
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Handshake" )
    protected void _ts_partialExecute_Handshake
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Handshake", _par_parameter_action );
        try
        {
            {
                scenName = " Connect ";
                DebugInfo.printMessageWithSeparator( 4, "!!!scenario try," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessageWithSeparator( 4, "!already connected" );
                    return;
                }
                scenParam.connectCounter++;
                DebugInfo.printMessage( 1, "scenario start," + scenName );
                try
                {
                    scenParam.target.connect( scenParam.current_connection );
                }
                catch( jatva.lang.TestException terr )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario TestException:" + scenName + terr );
                    scenParam.target.disconnect(  );
                    throw terr;
                }
                catch( IOException err )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario failed:" + scenName + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestRecordProtocol"
                        , "Handshake"
                        , "scenario failed" + scenName + err
                        );
                }
                scenParam.scenarioCounter++;
                scenName = " ClientHello ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.CONNECTED )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                short[] cs = {
                    TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )
                    , TLSCipherSuite.TLS_RSA_WITH_AES_128_CBC_SHA.getValue(  )
                    , TLSCipherSuite.TLS_RSA_WITH_AES_256_CBC_SHA256.getValue(  )}
                ;

                SignatureScheme[] sah = {
                    SignatureScheme.RSA_PKCS1_SHA256
                    , SignatureScheme.ECDSA_SECP256R1_SHA256
                    , SignatureScheme.RSA_PSS_RSAE_SHA256}
                ;

                SignatureAndHashAlgorithmExt hl_ext_sah = new SignatureAndHashAlgorithmExt( sah );

                NamedGroup[] sg = {
                    NamedGroup.FFDHEtest
                    , NamedGroup.FFDHE2048
                    , NamedGroup.SECP256R1}
                ;

                SupportedGroupsExt hl_ext_sg = new SupportedGroupsExt( sg );

                NamedGroup[] sendgrp = {
                    NamedGroup.SECP256R1}
                ;
                scenParam.current_connection.hskParams.generateClientKeyPairList( sendgrp );

                ProtocolVersion[] svdata = {
                    new ProtocolVersion( 0x03, 0x04 )
                    , new ProtocolVersion( 0x03, 0x03 )}
                ;

                TLSExtension hl_ext_sv = new SupportedVersionsExt( svdata );

                TLSExtension hl_ext_ks = new KeyShareClientHello( scenParam.current_connection.hskParams.clientKeyShareList );

                byte[] dataId = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8}
                ;

                Hello msg = new Hello( dataId, cs );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_sah );
                msg.addExtension( hl_ext_sg );
                msg.addExtension( hl_ext_ks );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenName = " Finished ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ServerFinished )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                Finished msg2 = null;
                try
                {
                    msg2 = new Finished( scenParam.current_connection, MessageDirection.getMessageDirection( scenParam.current_connection.localRole, TLSDirection.SEND ) );
                }
                catch( Exception err1 )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err1 );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestRecordProtocol"
                        , "Handshake"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }
                err = scenParam.msgSetContentAndSend( msg2, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenName = " Application ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.isHandshakeComplete(  ) )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ApplicationData msg3 = new ApplicationData( scenParam.applicationDataString.getBytes(  ) );
                err = scenParam.msgSetContentAndSend( msg3, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Handshake"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    @jatva.lang.annotation.JTSInternal
    protected class AbstractAction_RecordProtocolApplication
        extends jatva.lang.AbstractAction
    {
        @jatva.lang.annotation.JTSInternal
        int choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        int next_value_choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_RecordProtocolApplication()
        {
            super( 1, 1, 0 );
        }

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_RecordProtocolApplication( AbstractAction_RecordProtocolApplication _par_r )
        {
            super( _par_r );
            choice_1_0 = _par_r.choice_1_0;
            next_value_choice_1_0 = _par_r.next_value_choice_1_0;
        }

        @Override
        @jatva.lang.annotation.JTSInternal
        public Object clone()
        {
            return new AbstractAction_RecordProtocolApplication( this );
        }
    }

    @jatva.lang.annotation.ScenarioMethod( jtsName = "RecordProtocolApplication" )
    protected void _ts_partialExecute_RecordProtocolApplication
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "RecordProtocolApplication", _par_parameter_action );
        AbstractAction_RecordProtocolApplication _lv_action = (AbstractAction_RecordProtocolApplication)_par_parameter_action;
        jatva.lang.AbstractAction.IterationFlags _lv_tmp_flags =
            new jatva.lang.AbstractAction.IterationFlags( _lv_action );
        boolean _lv_tmp = false;
        jatva.lang.DummyClass.dummy( _lv_tmp );
        try
        {
            {
                scenName = " RecordProtocolApplication ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected || !scenParam.target.isHandshakeComplete(  ) )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ApplicationData msg = new ApplicationData( scenParam.applicationDataString.getBytes(  ) );

                RecordLayer rlmsg = new RecordLayer( msg );
                _lv_tmp_flags.setUsage( 0 );
                if( !(_lv_action.isIterationInitialized( 0 )) )
                {
                    _lv_action.choice_1_0 = 0;
                    if( _lv_action.choice_1_0 + 1 >= 13 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                else if( _lv_action.isIterationMove( 0 ) )
                {
                    _lv_action.choice_1_0++;
                    if( _lv_action.choice_1_0 + 1 >= 13 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                _lv_registrar.registerIterationVariableValue
                    ( jatva.tracer.ValueKind.CHOICE_ITERATION_VARIABLE
                    , "int"
                    , "choice_1"
                    , true
                    , _lv_action.choice_1_0
                    );
                switch( _lv_action.choice_1_0 )
                {
                    case 1:
                        {
                            DebugInfo.printMessage( 3, "send TLSContentType.TESTTYPEONLY" );

                            byte[] aad = {
                                TLSContentType.TESTTYPEONLY.getValue(  )
                                , 3
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.opaque_tls_type = TLSContentType.TESTTYPEONLY;
                        }

                        break;
                    case 2:
                        {
                            DebugInfo.printMessage( 3, "send TLSContentType.CHANGE_CIPHER_SPEC" );

                            byte[] aad = {
                                TLSContentType.CHANGE_CIPHER_SPEC.getValue(  )
                                , 3
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.opaque_tls_type = TLSContentType.CHANGE_CIPHER_SPEC;
                        }

                        break;
                    case 3:
                        {
                            DebugInfo.printMessage( 3, "send TLSContentType.ALERT" );

                            byte[] aad = {
                                TLSContentType.ALERT.getValue(  )
                                , 3
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.opaque_tls_type = TLSContentType.ALERT;
                        }

                        break;
                    case 4:
                        {
                            DebugInfo.printMessage( 3, "send TLSContentType.HANDSHAKE" );

                            byte[] aad = {
                                TLSContentType.HANDSHAKE.getValue(  )
                                , 3
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.opaque_tls_type = TLSContentType.HANDSHAKE;
                        }

                        break;
                    case 5:
                        {
                            DebugInfo.printMessage( 3, "send version.major 0" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 0
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.major = 0;
                        }

                        break;
                    case 6:
                        {
                            DebugInfo.printMessage( 3, "send version.major 2" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 2
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.major = 2;
                        }

                        break;
                    case 7:
                        {
                            DebugInfo.printMessage( 3, "send version.major 4" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 4
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.major = 4;
                        }

                        break;
                    case 8:
                        {
                            DebugInfo.printMessage( 3, "send version.major FF" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , (byte)0xFF
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.major = (byte)0xFF;
                        }

                        break;
                    case 9:
                        {
                            DebugInfo.printMessage( 3, "send version.minor 0" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 3
                                , 0
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.minor = 0;
                        }

                        break;
                    case 10:
                        {
                            DebugInfo.printMessage( 3, "send version.minor 2" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 3
                                , 2
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.minor = 2;
                        }

                        break;
                    case 11:
                        {
                            DebugInfo.printMessage( 3, "send version.minor 4" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 3
                                , 4
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.minor = 4;
                        }

                        break;
                    case 12:
                        {
                            DebugInfo.printMessage( 3, "send version.minor FF" );

                            byte[] aad = {
                                TLSContentType.APPLICATION.getValue(  )
                                , 3
                                , (byte)0xFF
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.version.minor = (byte)0xFF;
                        }

                        break;
                    default:
                        {
                            DebugInfo.printMessage( 3, "send TLSContentType.INVALID" );

                            byte[] aad = {
                                TLSContentType.INVALID.getValue(  )
                                , 3
                                , 3
                                , 0
                                , 0x20}
                            ;
                            scenParam.msgSetTestContent( rlmsg, aad, msg, scenName );
                            rlmsg.opaque_tls_type = TLSContentType.INVALID;
                        }

                        break;
                }

                Exception res = scenParam.msgSend( rlmsg, scenName );
                if( res != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", res );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "RecordProtocolApplication"
                , _lv_error
                );
        }
        finally
        {
            _lv_action.retrieveFlags( _lv_tmp_flags );
            _lv_registrar.scenarioMethodExit();
        }
    }

    public static
    void main( String[] args)
    {

        String fileName = "connectInfo_mail.txt";
        if( args.length > 0 )
            fileName = args[0];

        start( fileName );
    }


    public static
    void start( String fileName)
    {

        TestRecordProtocol scen = new TestRecordProtocol( fileName );

        Date dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "start test " + scen.currentClassName + " " + dt1.toString(  ) );
        scen.run(  );
        dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "end test: " + dt1.toString(  ) + " testCounter " + scen.scenParam.connectCounter + " scenarioCounter " + scen.scenParam.scenarioCounter );
        scen.scenParam.logFile.close(  );
    }

}
