package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.DebugInfo;

public class KeyShareServerHello extends TLSExtension
{
	public KeyShareEntry data = null; // 0..2^16-1 bytes

	public KeyShareServerHello(KeyShareEntry data) {
		this.type = 51;
		this.data = data;
	}

	public KeyShareServerHello(int length , KeyShareEntry data) {
		this(data);
		this.setLength(length);
	}

	@Override
	public int getDataSize() {
		if(data != null) 
			return data.getSize();
		else
			return 0;
	}

	@Override
	public void toByteArrayLengthField(byte[] msg, int position) {
	}

	@Override
	public void toByteArrayData(byte[] msg, int position) {
		if(data != null) {
			if(0 > data.toByteArray(msg,position)) 
				DebugInfo.printMessage(1,"!!! Error: KeyShareServerHello toByteArray return null");
		}
	}

	@Override
	public void printData() {
		DebugInfo.printMessage(1,"  KeyShareServerHello");
		data.print();
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
		KeyShareEntry extdata = KeyShareEntry.parseByteArray(msg,pos);

    	if(extdata == null) {
    		DebugInfo.printMessage(4,"===Error! KeyShareServerHello::parseByteArray: Data failed");
    		return null;
    	}

    	if(lengthExt != extdata.getSize()) {
    		DebugInfo.printMessage(4,"===Error! KeyShareServerHello::parseByteArray: Extension length wrong");
    		return null;
    	}
    	
//		params = set cookie;
		
		return new KeyShareServerHello(lengthExt, extdata);
	}
}
