package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.PSKexchangeMode;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;

public class PSKexchangeModesExt extends TLSExtension
{
        // data <1..2^16-1>
	public PSKexchangeModesExt(byte[] data) {
		type = 45; 
		this.data = data != null ? data : new byte[0];
	}

	public PSKexchangeModesExt(int length, byte[] data) {
		this(data); 
		this.setLength(length);
	}

	@Override
	public int getLengthFieldSize() {
		return 1;
	}

	@Override
	public void printData() {
		DebugInfo.printMessage(1,"  PSKexchangeModes:");
		if(data != null) {
                	for(int j=0; j<data.length; j++)
				DebugInfo.printMessage(1,"    " + PSKexchangeMode.toString(data[j]));
		}
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
		int len;
		int lengthFieldSize = 1;
    	if(lengthExt < lengthFieldSize) {
    		DebugInfo.printMessage(4,"===Error! PSKexchangeModesExt::parseByteArray: Extension length failed");
    		return null;
    	}
		len = msg[pos];
		pos += lengthFieldSize;

    	if(lengthExt != lengthFieldSize + len) {
    		DebugInfo.printMessage(4,"===Error! PSKexchangeModesExt::parseByteArray: Extension length wrong");
    		return null;
    	}
    	
    	byte[] extdata = new byte[len];
		System.arraycopy(msg, pos, extdata, 0, len);
		
//		params = set PSK exchange Mode;
		
		return new PSKexchangeModesExt(lengthExt, extdata);
	}
}
