package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.DebugInfo;

public class RenegotiationExtension extends TLSExtension
{
	public RenegotiationExtension() {
		type = (short)(0xFF01); length = 1; data = new byte[0];
	}
	public RenegotiationExtension(byte[] data) {
		this.type = (short)(0xFF01);
		this.data = data;
		this.setLength(); 
	}

	public RenegotiationExtension(int length, byte[] data) {
		this(data);
		this.setLength(length); 
	}

	@Override
	public int getLengthFieldSize() {
		return 1;
	}

	public boolean isEmpty() {
		return data.length == 0;
	}
	public boolean checkData(byte[] clientVerifyData) {
		boolean res = false;
		int i;

		DebugInfo.printMessage(5, "RenegotiationExtension::checkData");
		if(data != null  &&  clientVerifyData != null
		  && data.length == clientVerifyData.length) {
			for(res=true, i=0; i<data.length; i++)
				if(data[i] != clientVerifyData[i])  {
					res = false;
					break;
				}
		}
		DebugInfo.printMessage(4, "RenegotiationExtension::checkData return " + res);
		return res;
	}
	public boolean checkData(byte[] clientVerifyData, byte[] serverVerifyData) {
		boolean res = false;
		int i,j;

		DebugInfo.printMessage(5, "RenegotiationExtension::checkData");
		if(data != null  &&  clientVerifyData != null
		  && data.length == clientVerifyData.length + serverVerifyData.length) {
			res=true;
			for(i=0; i<clientVerifyData.length; i++)
				if(clientVerifyData[i] != data[i])  {
					DebugInfo.printMessage(4, "RenegotiationExtension::checkData clientVerifyData failed");
					res = false;
					break;
				}
			for(j=0; j<serverVerifyData.length; j++,i++)
				if(serverVerifyData[j] != data[i])  {
					DebugInfo.printMessage(4, "RenegotiationExtension::checkData serverVerifyData failed");
 					res = false;
					break;
				}
		}
		return res;
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
     	byte[] extdata = new byte[lengthExt];
		System.arraycopy(msg, pos, extdata, 0, lengthExt);
		
//		params = set new param;
		
		return new RenegotiationExtension(lengthExt, extdata);
	}
}
