package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.SignatureScheme;

public class SignatureAlgorithmCertExt extends SignatureAndHashAlgorithmExt
{
	public SignatureAlgorithmCertExt(SignatureScheme[] sah) {
		super(sah);
		this.type = 50; 
	}

	public SignatureAlgorithmCertExt(int length, SignatureScheme[] sah) {
		super(length,sah);
		this.type = 50; 
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
		int len;
		int lengthFieldSize = 2;
    	if(lengthExt < lengthFieldSize) {
    		DebugInfo.printMessage(4,"===Error! SignatureAlgorithmCertExt::parseByteArray: Extension length failed");
    		return null;
    	}
		len = ConvertTypes.ntohs(msg,pos);
		pos += lengthFieldSize;

    	if(lengthExt != lengthFieldSize + len) {
    		DebugInfo.printMessage(4,"===Error! SignatureAlgorithmCertExt::parseByteArray: Extension length wrong");
    		return null;
    	}
    	
		if(len % 2 != 0) {
    		DebugInfo.printMessage(4,"===Error! SignatureAlgorithmCertExt::parseByteArray:  length must be even");
    		return null;
		}
		
		SignatureScheme[] extdata = new SignatureScheme[len/2];
    	for(int i=0; i<extdata.length; i++) {
    		extdata[i] = SignatureScheme.valueOf(ConvertTypes.ntohs(msg, pos));
    		pos += 2;
    	}

		return new SignatureAlgorithmCertExt(lengthExt, extdata);
	}
}
