package ru.ispras.telecomtesk.tlsv13;

import java.io.*;
import java.util.*;

public  class LoginInfo {

	Properties info = new Properties();
	BufferedReader br;
	FileInputStream fin = null;
	
	public LoginInfo() {
		 try {
			br = new BufferedReader(new InputStreamReader(System.in, "UTF-8"));
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
	}

	public void readFromFile(String name)
	{
		try {
			fin = new FileInputStream(name);			
		} catch (FileNotFoundException e) {
			System.out.println("File not found");
		}
		
		try {
			if (fin != null) {
				info.load(fin);
				fin.close();
			}
		} catch (IOException e) {
			System.out.println("Error reading file.");
		}		
	}
	
	public String getValue(String key)
	{
		return info.getProperty(key);
	}

	/** Return the value of the property or the specified default value 
	 * if the property is not defined.
	 * @param key the name of the property
	 * @param defaultValue the default value
	 * @return the property value or the default value
	 */
	public String getValue(String key, String defaultValue)
	{
		return info.getProperty(key, defaultValue);
	}

	/** Return the value of the property or throw an exception if the property is not defined.
	 * @param key the name of the property
	 * @param exceptionMessage message of the {@link IllegalArgumentException} when the property value
	 * is not found.
	 * @return the property value
	 * @throws IllegalArgumentException if the property is not defined
	 */
	public String getExistingValue(String key, String exceptionMessage)
	{
		String property = info.getProperty(key);
		if (property == null) {
			throw new IllegalArgumentException(
					(exceptionMessage == null)? "Property {" + key + "} not defined"
							: exceptionMessage
					);
		}
		return property;
	}

	/** Return the value of the property or throw an exception if the property is not defined.
	 * <p>Same as {@link LoginInfo#getExistingValue(String, String)} with the second argument 
	 * set to <code>null</code>.
	 * @param key the name of the property.
	 * @return the property value
	 * @throws IllegalArgumentException if the property is not defined
	 */
	public String getExistingValue(String key)
	{
		return getExistingValue(key, null);
	}

}
