package ru.ispras.telecomtesk.tlsv13.TLSAlgorithms;

public enum HandshakeMessageType {
          HELLO_REQUEST_RESERVED(0),
          CLIENT_HELLO(1),
          SERVER_HELLO(2),
          NEW_SESSION_TICKET(4),
          END_OF_EARLY_DATA(5),
          ENCRYPTED_EXTENSIONS(8),
          CERTIFICATE(11),
          SERVER_KEY_EXCHANGE_RESERVED(12),
          CERTIFICATE_REQUEST(13),
          SERVER_HELLO_DONE_RESERVED(14),
          CERTIFICATE_VERIFY(15),
          CLIENT_KEY_EXCHANGE_RESERVED(16),
          FINISHED(20),
          KEY_UPDATE(24),
          MESSAGE_HASH(254),
          UNKNOWN(255);
	
	public byte type;
	
	private HandshakeMessageType(int type) {
		this.type = (byte)type;
	}
	public byte getValue(){
		return type;
	}
	public static HandshakeMessageType valueOf(int type) {
		switch (type) {
		case 0: return HELLO_REQUEST_RESERVED;
		case 1: return CLIENT_HELLO;
		case 2: return SERVER_HELLO;
		case 4: return NEW_SESSION_TICKET;
		case 5: return END_OF_EARLY_DATA;
		case 8: return ENCRYPTED_EXTENSIONS;
		case 11: return CERTIFICATE;
		case 12: return SERVER_KEY_EXCHANGE_RESERVED;
		case 13: return CERTIFICATE_REQUEST;
		case 14: return SERVER_HELLO_DONE_RESERVED;
		case 15: return CERTIFICATE_VERIFY;
		case 16: return CLIENT_KEY_EXCHANGE_RESERVED;
		case 20: return FINISHED;
		case 24: return KEY_UPDATE;
		case 254: return MESSAGE_HASH;
		default: return UNKNOWN;
		}
	}

	public String toString() {
		return ("" + this.name() + "<" + type + ">");
	}

	public static String toString(int type) {
		return ("" + HandshakeMessageType.valueOf(type).name() + "<" + type + ">");
	}
}
