package ru.ispras.telecomtesk.tlsv13.TLSAlgorithms;

public enum PSKexchangeMode {
	PSK_KE(0), 
	PSK_DHE_KE(1),
	UNKNOWN(0xFF);
	
	public byte mode;
	
	private PSKexchangeMode(byte mode) {
		this.mode = mode;
	}
	private PSKexchangeMode(int mode) {
		this.mode = (byte)mode;
	}
	public byte getValue(){
		return mode;
	}

	public static PSKexchangeMode valueOf(byte mode) {
		switch (mode) {
		case 0: return PSK_KE;
		case 1: return PSK_DHE_KE;
		default: return UNKNOWN;
		}
	}

	public static String codeToString(byte code, String name) {
		String tmpstr = String.format("%02x", code);
		if(tmpstr.length() > 2)
			tmpstr = tmpstr.substring(tmpstr.length()-2);
		return "0x" + tmpstr + " [" + name + "]";
	}

	public String toString() {
		return "" + this.mode + " [" + this.name() + "]";
	}

	public static String toString(byte mode) {
		return PSKexchangeMode.valueOf(mode).toString();
	}
}
