package ru.ispras.telecomtesk.tlsv13.TLSState;


import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import javax.xml.bind.DatatypeConverter;

import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.MACAlgorithm;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.TLSCipherSuite;

public class testTLSKeyDerivation
{

	public static void main(String[] args) throws Exception {

		byte[] salt = {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c};
		byte[] ikm = {0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b};
		byte[] info = {(byte)0xf0,(byte)0xf1,(byte)0xf2,(byte)0xf3,(byte)0xf4,(byte)0xf5,(byte)0xf6,(byte)0xf7,(byte)0xf8,(byte)0xf9};
		int len = 42;

		byte[][] msgHash = null;
//		byte[] res0 = TLSKeyDerivation.mac(MACAlgorithm.hmac_sha256, salt, msgHash);
//		DebugInfo.printDump(1, res0, "res0: ");
//		byte[] res1 = TLSKeyDerivation.TLS_HKDF_Extract(MACAlgorithm.hmac_sha256, null, ikm);
//		DebugInfo.printDump(1, res1, "res1: ");
//		byte[] res2 = TLSKeyDerivation.TLS_HKDF_Expand(MACAlgorithm.hmac_sha256, res1, null , len);
//		DebugInfo.printDump(1, res2, "res2: ");

		TLSSecurityParameters sp = new TLSSecurityParameters();
		sp.setAlgorithmParams(TLSCipherSuite.TLS_AES_128_GCM_SHA256);
		String scl = "CB02901BBAAF8AF345461F8F5F606D016247FC246BA8CD8A42DE790E4A5ED983";
		String ssr = "ED5B64D8672F68CC7DECEA7309EEF48340555B2CC3EAD2CDA8CE3C7FC912BBDF";
		sp.client_handshake_traffic_secret = DatatypeConverter.parseHexBinary(scl);
		sp.server_handshake_traffic_secret = DatatypeConverter.parseHexBinary(ssr);
		sp.createHandshakeTrafficKeys();
		sp.printDump(1);

	}
	
	
}
